
 #Simulation for disease mapping of areal data using similar set-up as lung cancer in Biometrics(2005-Banerjee et al.): Binomial spatial model:


date()
set.seed(1980)
path<-getwd()

#install.packages("INLA", repos="https://inla.r-inla-download.org/R/stable")
library("INLA")
#library("spdep")
#library("rgdal")

#library("dclone")
library("Matrix")
library("igraph")
library("lme4")
library("MASS")
library("psych")

B=10
            s1=0

#========================
#adjacency matrix 
adj = c(11,  31,  69,  9,  58,  33,	48,	18,
        27,	71,	30,	13,	82,	62,		
        14,	54,	44,	15,	29,	80,	56,	
        45,	68,	39,	36,	31,	11,	29,	15,	57,
        73,	49,	48,	71,				
        78,	75,	76,	37,				
        22,	46,	83,	8,	52,	40,	81,		
        83,	17,	64,	65,	52,	7,			
        1,	69,	58,						
        27,	70,	72,	43,	86,				
        29,	4,	31,	1,	18,	49,	77,	80,	
        37,	76,	34,	65,	87,				
        82,	2,	30,	58,					
        54,	3,	56,	84,					
        60,	57,	4,	29,	3,	44,			
        38,								
        32,	51,	64,	8,	83,				
        11,	1,	48,	49,					
        25,	66,	70,	27,	62,	82,			
        50,	74,	25,	55,					
        61,	26,	56,	77,					
        46,	7,	81,	24,					
        50,	55,	85,	28,					
        22,	81,	74,	50,					
        79,	55,	20,	66,	19,				
        78,	84,	56,	21,	75,				
        19,	70,	10,	86,	2,	62,			
        23,	85,							
        15,	4,	11,	80,	3,				
        2,	71,	48,	33,	13,				
        4,	36,	69,	1,	11,				
        53,	17,	46,						
        48,	1,	58,	30,					
        12,	76,	61,	73,	47,	65,			
        68,	45,							
        39,	4,	31,	69,					
        6,	12,	87,						
        69,	16,							
        68,     4,      36,						
        81,	7,	52,	72,	70,	66,			
        87,	42,	59,						
        41,	87,	64,	51,					
        10,	72,	65,	47,	86,				
        54,	60,	15,	3,					
        35,	68,	4,	57,	60,				
        32,	83,	7,	22,					
        34,	73,	86,	43,	65,				
        5,	49,	18,	1,	33,	30,	71,		
        77,	11,	18,	48,	5,	73,			
        24,	20,	55,	23,					
        53,	59,	42,	64,	17,				
        7,	8,	65,	72,	40,				
        67,	51,	32,						
        60,	44,	3,	14,					
        79,	85,	23,	50,	20,	25,			
        84,	14,	3,	80,	77,	21,	26,		
        45,	4,	15,	63,	60,				
        13,	33,	1,	9,					
        41,	51,	67,						
        45,	57,	63,	15,	44,	54,			
        76,	75,	21,	73,	34,				
        27,	2,	82,	19,					
        60,	57,							
        17,	51,	42,	87,	65,	8,			
        43,	72,	52,	8,	64,	87,	12,	34,	47,
        74,	81,	40,	70,	19,	25,			
        59,	53,							
        35,	39,	45,	4,					
        36,	31,	1,	9,	38,				
        66,	40,	72,	10,	27,	19,			
        86,	73,	5,	48,	30,	2,			
        65,	43,	10,	70,	40,	52,			
        86,	47,	34,	61,	77,	49,	5,	71,
        24,	81,	66,	20,					
        6,	78,	26,	61,	76,				
        12,	6,	75,	61,	34,				
        21,	56,	80,	11,	49,	73,			
        84,	26,	75,	6,					
        85,	55,	25,						
        56,	3,	29,	11,	77,				
        24,	22,	7,	40,	66,	74,			
        19,	62,	2,	13,					
        46,	17,	8,	7,					
        14,	56,	26,	78,					
        28,	23,	55,	79,					
        47,	73,	71,	27,	10,	43,			
        37,	12,	65,	64,	42,	41)

#number of neighbours of each county:
num = c(8,6,7,9,4,4,7,6,3,5,8,5,4,4,6,1,5,4,6,4,4,4,4,4,5,5,
        6,2,5,5,5,3,4,6,2,4,3,2,3,6,3,4,5,4,5,4,5,7,6,4,5,
        5,3,4,6,7,5,4,3,6,5,4,2,6,9,6,2,4,5,6,6,6,8,4,5,5,6,
        4,3,5,6,4,4,4,4,6,6)

########################
#True values for model parameters:
I=87
beta0=beta1=0.1
sig2.i=0.0001
gamma=0.50
ni=1

K=20 #NUMBER OF CLONES
N=K*I
MC=100 #number of monte carlo for approximation of expectation needed for the mspe (Taylor)
parameters.dc <- c("beta0", "beta1", "sig2.i","gamma")
x<-runif(I,0,1)
X<-cbind(rep(1,I),x)
#===================================================================
statstotal.dc<-matrix(0,1000,4)
colnames(statstotal.dc)<-c("beta0", "beta1", "sig2.i","gamma")
stats.dc<-list()
mean.dc<-MSE.dc<-sd.dc<-Bias.dc<-RB.dc<-c(rep(0,4))

paramvalue.dc<-c(rep(0,4))
outbound.dc<-rep(0,B)

MSPE<-MSPE.logit<-MU.EB<-MU<-MU.logit<-rep(0,I)
mspe.te<-rep(c(0),I)
#----------------------------------
ss<-rep(0,(I+1))
ss[1]<-1
for(i in 2:(I+1)){ss[i]<-ss[i-1]+num[i-1]}
################Definition of Q and Cm (see Leroux, Lei, Breslow, 1999)###################
Q<-diag(num)
for(i in 1:I){
  a<-ss[i]
  for(j in 1:num[i]){
    Q[i,adj[a+j-1]]<--1
  }
}
Cm<-diag(I)-Q
#=============================================
mu.i<-rep(0,I)
cov.i<-sig2.i*solve(diag(I)-(gamma/max(eigen(Cm)$values))*Cm) 
#Sigma.i <- make.symmetric(cov.i)
Sigma.i <-forceSymmetric(cov.i)
#=============================================
######Simulation from  Binomial (bernouli) distribution:#######
n=1
for(n in 1:B){
  
  ETA.temp<-matrix(c(0),1000,I)
  for(i in 1:1000){
    ETA.temp[i,]<-mvrnorm(1,mu.i,Sigma.i)
  }
  ETA<-apply(ETA.temp,2,mean)
  
  
  mu<-rep(0,I)
  y.ran<-rep(0,I)
  tem.logit<-rep(0,I)
  for(i in 1:I){
    tem.logit[i]<-beta0+beta1*x[i]+ETA[i]
    mu[i]<-exp(tem.logit[i])/(1+exp(tem.logit[i]))
    y.ran[i]<-rbinom(1,ni,mu[i])
  }
  
  MU<-MU+mu
  MU.logit<-MU.logit+tem.logit
  #-----------------------------
  if(n>s1){
    
    #Cloned data:
    "yran.k"<-rep(y.ran,K)
    "num.k"<-c(1:N)
    "x.k"<-rep(x,K)
    
    #print(yran.k)
    Cm.k<-diag(0,N)
    a<-1
    b<-I
    for(i in 1:K){Cm.k[a:b,a:b]<-Cm
    a<-a+I
    b<-a+I-1
    }
    
    clone.data.ran<-cbind(yran.k,num.k,x.k)
    clone.data.ran<-as.data.frame(clone.data.ran)
    
    idx<-c(1:N)
    clone.data.ran$idx<-c(1:N)
    #########################################
    form3 <- yran.k ~ x.k + f(idx, model = "generic1", Cmatrix = Cm.k)
    m1.ran <- inla (form3, family = "binomial", data = clone.data.ran, control.predictor = list(compute = TRUE))
    summary(m1.ran)
    ###########################################################
      sigma2.hat<-1/(m1.ran$summary.hyperpar[1,1])
    param.ran<-c(m1.ran$summary.fixed[1,1],m1.ran$summary.fixed[2,1],sigma2.hat, m1.ran$summary.hyperpar[2,1])
    v.sigma2.hat<-(as.numeric(m1.ran$summary.hyperpar[1,2]^2))*((sigma2.hat)^4) #Delta method
    temp.ran<-K*c(as.numeric(m1.ran$summary.fixed[1,2]^2), as.numeric(m1.ran$summary.fixed[2,2]^2), v.sigma2.hat ,        
    as.numeric(m1.ran$summary.hyperpar[2,2]^2))
    Sigma.alpha.ran<-diag(temp.ran)
    #==============================
    print(param.ran)
    print(Sigma.alpha.ran)
    #####################################
    beta.hat.ran<-c(param.ran[1],param.ran[2])
    sig2.hat.ran<-param.ran[3] 
    gamma.hat.ran<-param.ran[4] 
    #####################################
    cov.i.ran<-sig2.hat.ran*solve(diag(I)-(gamma.hat.ran/max(eigen(Cm)$values))*Cm) 
 #   Sigma.i.ran <- make.symmetric(cov.i.ran)
    Sigma.i.ran <-forceSymmetric(cov.i.ran)
    #############################################################
    ETA.tem<-matrix(c(0),1000,I)
    for(i in 1:1000){
      ETA.tem[i,]<-mvrnorm(1,mu.i,Sigma.i.ran)
    }
    ETA.ran<-apply(ETA.tem,2,mean)
    
    z.tem<-rep(0,I)
    mu.EB<-rep(0,I)
    for(i in 1:I){
      z.tem[i]<-(y.ran[i]*exp(-ETA.ran[i])*(1+exp(ETA.ran[i]))^2 -(1+exp(ETA.ran[i]))+ ETA.ran[i] -X[i,]%*%beta.hat.ran) 
    }
    
    P<-diag(exp(-ETA.ran)*(1+exp(ETA.ran))^2) 
    tem.hat.logit<-X%*%beta.hat.ran+Sigma.i.ran%*%(solve(Sigma.i.ran+P))%*%z.tem
    mu.EB<-exp(tem.hat.logit)/(1+exp(tem.hat.logit))
    MU.EB<-MU.EB+mu.EB
    MSPE<-MSPE+(mu.EB-mu)^2
    MSPE.logit<-MSPE.logit+(tem.hat.logit-tem.logit)^2
    ###############################################
    #Get the necessary expectations numerically needed in the mspe-taylor expansion:
    sum1=rep(0,4)
    sum2=matrix(0,4,4)
    
    RRR=MC  #number of MC for approximation:
    param.ran1<-matrix(0,RRR,4)
    for( i in 1:RRR){   
      
      print(i)
      ETA5.temp<-matrix(c(0),1000,I)
      for(j in 1:1000){
        ETA5.temp[j,]<-mvrnorm(1,mu.i,Sigma.i)
      }
      ETA5<-apply(ETA5.temp,2,mean)
      
      
      pi5<-rep(0,I)
      y.ran5<-rep(0,I)
      for(j in 1:I){
        mu5<-beta0+beta1*x[i]+ETA5[j]
        pi5[j]<-exp(mu5)/(1+exp(mu5))
        y.ran5[j]<-rbinom(1,ni,pi5[j])
      }
      #print(y.ran5)
      #-----------------------------
      #Cloned data:
      "yran5.k"<-rep(y.ran5,K)
      "num5.k"<-c(1:N)
      
      clone.data.ran5<-cbind(yran5.k,num5.k,x.k)
      clone.data.ran5<-as.data.frame(clone.data.ran5)
      #########################################
      form3.ran5 <- yran5.k ~ x.k + f(idx, model = "generic1", Cmatrix = Cm.k)
      m1.ran5 <- inla (form3.ran5, family = "binomial", data = clone.data.ran5, control.predictor = list(compute = TRUE))
      #summary(m1.ran5)
      ###########################################################
      sigma2.hat.ran5<-1/(m1.ran5$summary.hyperpar[1,1])
      param.ran1[i,]<-c(m1.ran5$summary.fixed[1,1],m1.ran5$summary.fixed[2,1],sigma2.hat.ran5, m1.ran5$summary.hyperpar[2,1])
      print(param.ran1[i,])
      
      sum1=sum1+matrix(c((param.ran1[i,1]-beta.hat.ran[1]),(param.ran1[i,2]-beta.hat.ran[2]),(param.ran1[i,3]-sig2.hat.ran),(param.ran1[i,4]-gamma.hat.ran)),4,1)
      sum2=sum2+matrix(c((param.ran1[i,1]-beta.hat.ran[1]),(param.ran1[i,2]-beta.hat.ran[2]),(param.ran1[i,3]-sig2.hat.ran),(param.ran1[i,4]-gamma.hat.ran)),4,1)%*%matrix(c((param.ran1[i,1]-beta.hat.ran[1]),(param.ran1[i,2]-beta.hat.ran[2]),(param.ran1[i,3]-sig2.hat.ran),(param.ran1[i,4]-gamma.hat.ran)),1,4)
    }
    
    Ealpha=sum1/RRR
    Covalpha=sum2/RRR
    #=============================================
    
    paramvalue.dc<-c(beta0,beta1,sig2.i,gamma)
    
    if(max(abs(param.ran[1]-paramvalue.dc[1]))>0.01 || max(abs(param.ran[2]-paramvalue.dc[2]))>0.01 || max(abs(param.ran[3]-paramvalue.dc[3]))>0.25 | max(abs(param.ran[4]-paramvalue.dc[4]))>0.001){
      outbound.dc[n]<-1
    }
    print(paste("outbound for parameters in DC",n,"is", outbound.dc[n]))
    
   # if(outbound.sig2.dc[n]==0){
      
      mean.dc<-mean.dc+param.ran
      MSE.dc<-MSE.dc+((param.ran-paramvalue.dc)^2)
      sd.dc<-sd.dc+sqrt(temp.ran)
      RB.dc<-RB.dc+(param.ran/paramvalue.dc-1)
      Bias.dc<-Bias.dc+sqrt((param.ran-paramvalue.dc)^2)
      
      print(paste(" ****** mean nodes for DC",n))
      print(param.ran)
      print(paste(" ******** MSE nodes for DC",n))
      print(((param.ran-paramvalue.dc)^2))
      print(paste(" ******** bias nodes for DC",n))
      print((sqrt((param.ran-paramvalue.dc)^2)))
      print(paste(" ******* sd nodes for DC",n))
      print(sqrt(temp.ran))
      ###############################    mspe     ###############################################################
      ##########################################################################################################
      Z=diag(I)
      
      R<-Sigma.i.ran + P
      Rdiag<-diag(R)
      Sigmasigma2u<-solve(diag(I)-(gamma.hat.ran/max(eigen(Cm)$values))*Cm)
      Rsigma2u<-Sigmasigma2u
      Sigmalambdau=(1/max(eigen(Cm)$values))*(Sigma.i.ran%*%solve(diag(I)-(gamma.hat.ran/max(eigen(Cm)$values))*Cm)%*%(Cm))
      Rlambdau=Sigmalambdau
      Sigmalambda2u=( Sigmalambdau + (1/(max(eigen(Cm)$values)*sig2.hat.ran))*(Sigma.i.ran%*%Cm%*%Sigma.i.ran))%*%solve(diag(I)-(gamma.hat.ran/max(eigen(Cm)$values))*Cm)%*%((1/max(eigen(Cm)$values))*Cm)
      Rlambda2u=Sigmalambda2u
      Sigmasigma2ulambdau= (1/(max(eigen(Cm)$values)*sig2.hat.ran))*solve(diag(I)-(gamma.hat.ran/max(eigen(Cm)$values))*Cm)%*%(Cm)%*%Sigma.i.ran
      Rsigma2ulambdau=Sigmasigma2ulambdau
      
      
      g1sigma2u<-rep(0,I)
      g1lambda<-rep(0,I)
      g1<-rep(0,I)
      g2<-rep(0,I)
      g1sigmalambda <-rep(0,I)
      g1sigmasigma <-rep(0,I)
      g1lambdalambda<-rep(0,I)
      Esigma2<-rep(0,I)
      Elambda2<-rep(0,I)
      g11<-rep(0,I)
      g12<-rep(0,I)
      mspeta<-rep(0,I)
      
      
      g1all<-(Sigma.i.ran -(Sigma.i.ran%*%(t(Z))%*%(solve(R))%*%Z%*%Sigma.i.ran))
      g1<-diag(g1all)
      g1sigma2u<-(Sigmasigma2u -(Sigmasigma2u%*%(t(Z))%*%(solve(R))%*%Z%*%Sigma.i.ran) + (Sigma.i.ran%*%(t(Z))%*%(solve(R))%*%Rsigma2u%*%(solve(R))%*%Z%*%Sigma.i.ran) - (Sigma.i.ran%*%(t(Z))%*%(solve(R))%*%Z%*%Sigmasigma2u))
      g1sigma2udiag=diag(g1sigma2u)
      g1lambda<-(Sigmalambdau -(Sigmalambdau%*%(t(Z))%*%(solve(R))%*%Z%*%Sigma.i.ran) + (Sigma.i.ran%*%(t(Z))%*%(solve(R))%*%Rlambdau%*%(solve(R))%*%Z%*%Sigma.i.ran) - (Sigma.i.ran%*%(t(Z))%*%(solve(R))%*%Z%*%Sigmalambdau))
      g1lambdadiag=diag(g1lambda)
      g1sigmasigma<-((Sigmasigma2u%*%(t(Z))%*%(solve(R))%*%Rsigma2u%*%(solve(R))%*%Z%*%Sigma.i.ran) - (Sigmasigma2u%*%(t(Z))%*%(solve(R))%*%Z%*%Sigmasigma2u) + (Sigmasigma2u%*%(t(Z))%*%(solve(R))%*%Rsigma2u%*%(solve(R))%*%Z%*%Sigma.i.ran) - (Sigma.i.ran%*%(t(Z))%*%(solve(R))%*%Rsigma2u%*%(solve(R))%*%Rsigma2u%*%(solve(R))%*%Z%*%Sigma.i.ran)- (Sigma.i.ran%*%(t(Z))%*%(solve(R))%*%Rsigma2u%*%(solve(R))%*%Rsigma2u%*%(solve(R))%*%Rsigma2u%*%(solve(R))%*%Z%*%Sigma.i.ran) + (Sigma.i.ran%*%(t(Z))%*%(solve(R))%*%Rsigma2u%*%(solve(R))%*%Z%*%Sigmalambdau) - (Sigmasigma2u%*%(t(Z))%*%(solve(R))%*%Z%*%Sigmasigma2u) + (Sigma.i.ran%*%(t(Z))%*%(solve(R))%*%Rsigma2u%*%(solve(R))%*%Z%*%Sigmasigma2u)) 
      g1sigmasigmadiag=diag(g1sigmasigma)
      g1lambdalambda<-(Sigmalambda2u- (Sigmalambda2u%*%(t(Z))%*%(solve(R))%*%Z%*%Sigma.i.ran) +(Sigmalambdau%*%(t(Z))%*%(solve(R))%*%Rlambdau%*%(solve(R))%*%Z%*%Sigma.i.ran) - (Sigmalambdau%*%(t(Z))%*%(solve(R))%*%Z%*%Sigmalambdau) + (Sigmalambdau%*%(t(Z))%*%(solve(R))%*%Rlambdau%*%(solve(R))%*%Z%*%Sigma.i.ran) - (Sigma.i.ran%*%(t(Z))%*%(solve(R))%*%Rlambdau%*%(solve(R))%*%Rlambdau%*%(solve(R))%*%Z%*%Sigma.i.ran)+(Sigma.i.ran%*%(t(Z))%*%(solve(R))%*%Rlambda2u%*%(solve(R))%*%Z%*%Sigma.i.ran) -(Sigma.i.ran%*%(t(Z))%*%(solve(R))%*%Rlambdau%*%(solve(R))%*%Rlambdau%*%(solve(R))%*%Z%*%Sigma.i.ran) - (Sigmalambdau%*%(t(Z))%*%(solve(R))%*%Z%*%Sigmalambdau) + 2*(Sigma.i.ran%*%(t(Z))%*%(solve(R))%*%Rlambdau%*%(solve(R))%*%Z%*%Sigmalambdau) -(Sigma.i.ran%*%(t(Z))%*%(solve(R))%*%Z%*%Sigmalambda2u)) 
      g1lambdalambdadiag=diag(g1lambdalambda)
      g1sigmalambda<-(Sigmasigma2ulambdau- (Sigmasigma2ulambdau%*%(t(Z))%*%(solve(R))%*%Z%*%Sigma.i.ran) +(Sigmasigma2u%*%(t(Z))%*%(solve(R))%*%Rlambdau%*%(solve(R))%*%Z%*%Sigma.i.ran) - (Sigmasigma2u%*%(t(Z))%*%(solve(R))%*%Z%*%Sigmalambdau) + (Sigmalambdau%*%(t(Z))%*%(solve(R))%*%Rsigma2u%*%(solve(R))%*%Rsigma2u%*%(solve(R))%*%Z%*%Sigma.i.ran) - (Sigma.i.ran%*%(t(Z))%*%(solve(R))%*%Rlambdau%*%(solve(R))%*%Rsigma2u%*%(solve(R))%*%Z%*%Sigma.i.ran)+(Sigma.i.ran%*%(t(Z))%*%(solve(R))%*%Rsigma2ulambdau%*%(solve(R))%*%Z%*%Sigma.i.ran) -(Sigma.i.ran%*%(t(Z))%*%(solve(R))%*%Rsigma2u%*%(solve(R))%*%Rlambdau%*%(solve(R))%*%Z%*%Sigma.i.ran) + (Sigma.i.ran%*%(t(Z))%*%(solve(R))%*%Rsigma2u%*%(solve(R))%*%Z%*%Sigmalambdau) - (Sigmalambdau%*%(t(Z))%*%(solve(R))%*%Z%*%Sigmasigma2u)+(Sigma.i.ran%*%(t(Z))%*%(solve(R))%*%Rlambdau%*%(solve(R))%*%Z%*%Sigmasigma2u) -(Sigma.i.ran%*%(t(Z))%*%(solve(R))%*%Z%*%Sigmasigma2ulambdau))
      g1sigmalambdadiag=diag(g1sigmalambda)
      
      
      sum3=matrix(0,I,I)
      
      for(j in 1:RRR){  #MC approximations
        ETA.temp1<-matrix(c(0),1000,I)
        for(i in 1:1000){
          ETA.temp1[i,]<-mvrnorm(1,mu.i,Sigma.i)
        }
        ETA1<-apply(ETA.temp1,2,mean)
        
        
        mu1<-rep(0,I)
        y.ran1<-rep(0,I)
        z<-rep(0,I)
        for(i in 1:I){
          tem<-beta0+beta1*x[i]+ETA1[i]
          mu1[i]<-exp(tem)/(1+exp(tem))
          y.ran1[i]<-rbinom(1,ni,mu1[i])
          z[i]=(y.ran1[i]*exp(-ETA1[i])*(1+exp(ETA1[i]))^2 -(1+exp(ETA1[i]))+ ETA1[i] -X[i,]%*%beta.hat.ran) 
        }
        sum3=sum3+matrix(z,I,1)%*%matrix(z,1,I)
      }
      Ez=sum3/RRR
      
      #Ebeta2=(1 -  diag(solve(R)%*%Sigma.i.ran))^2
      
      for(i in 1:I){
        Esigma2[i]=Z[i,]%*%((Sigmasigma2u%*%t(Z)%*%solve(Z%*%Sigma.i.ran%*%t(Z) + P) - Sigma.i.ran%*%t(Z)%*%solve(Z%*%Sigma.i.ran%*%t(Z) + P)%*%Z%*%Sigmasigma2u%*%t(Z)%*%solve(Z%*%Sigma.i.ran%*%t(Z) + P))%*%Ez%*%(solve(Z%*%Sigma.i.ran%*%t(Z) + P)%*%Z%*%Sigmasigma2u%*% - solve(Z%*%Sigma.i.ran%*%t(Z)+P)%*%Z%*%Sigmasigma2u%*%t(Z)%*%solve(Z%*%Sigma.i.ran%*%t(Z) + P)%*%Z%*%Sigma.i.ran))%*%(matrix(Z[i,],I,1))
        
        Elambda2[i]=Z[i,]%*%((Sigmalambdau%*%t(Z)%*%solve(Z%*%Sigma.i.ran%*%t(Z) + P) - Sigma.i.ran%*%t(Z)%*%solve(Z%*%Sigma.i.ran%*%t(Z) + P)%*%Z%*%Sigmalambdau%*%t(Z)%*%solve(Z%*%Sigma.i.ran%*%t(Z) + P))%*%Ez%*%(solve(Z%*%Sigma.i.ran%*%t(Z) + P)%*%Z%*%Sigmalambdau%*% - solve(Z%*%Sigma.i.ran%*%t(Z)+P)%*%Z%*%Sigmalambdau%*%t(Z)%*%solve(Z%*%Sigma.i.ran%*%t(Z) + P)%*%Z%*%Sigma.i.ran))%*%(matrix(Z[i,],I,1))
      }
      
      
      for(i in 1:I){
      k2=cbind(g1sigmasigmadiag[i],g1sigmalambdadiag[i])
      k3=cbind(g1sigmalambdadiag[i],g1lambdalambdadiag[i])
      k4=rbind(k2,k3)
      g12[i]=0.5*tr(k4%*%Covalpha[3:4,3:4])
      g11[i]=(cbind(g1sigma2udiag[i],g1lambdadiag[i]))%*%Ealpha[3:4] 
      
      tem<-(X[i,] - (solve(R)%*%Sigma.i.ran%*%X)[i,] )%*%t((X[i,] - (solve(R)%*%Sigma.i.ran%*%X)[i,] ))
      tem1<-matrix(c(tem[1,1],tem[1,2],0,0, tem[2,1],tem[2,2],0,0, 0,0,Esigma2[i],0, 0,0,0,Elambda2[i]),4,4,byrow=T )
      g2[i]= tr(tem1%*%Covalpha)
      mspeta[i]= g1[i] - g11[i] - g12[i] + g2[i]
      mspe.te[i]<-mspe.te[i]+mspeta[i]
      }
     
    #} #for outbound
  }#for n>s1
}# for loop B
    ###################################################
    RB1<-rep(0,I)
    
    for(i in 1:I){
      RB1[i] <- (mspe.te[i]    - MSPE[i])/MSPE[i]
    }
    
    print(RB1)
    ##################################################
    #  rm(a123)
    #  stats<-list()
    #  for(l in 1:R){
    #  load(file=paste(path,"stats",l," .RData",sep=" "))
    #  stats[[l]]<-a123
    #  rm(a123)}
    print(paste("##################################################"))
    print(paste("##################################################"))
    print(paste("##################################################"))
    print(paste("##################################################"))
    print(paste("##################################################"))
    print(paste("############## final results for",B,"#####################"))
    print(paste("##################################################"))
    print(paste("##################################################"))
    print(paste("##################################################"))
    print(paste("##################################################"))
    print(paste("##################################################"))
    print(paste("##################################################"))
    print(paste("*************"))
    print(paste("############## DC",B,"#####################"))
    
    print(paste(" ********* aggregated mean nodes for DC"))
    print(mean.dc)
    print(paste(" ******** aggregate Bias for DC"))
    print(Bias.dc)
    print(paste(" ******** aggregate MSE for DC"))
    print(MSE.dc)
    print(paste(" ******** aggregate sd for DC"))
    print(sd.dc)
    print(paste(" ******** aggregate RB for DC"))
    print(RB.dc)
    
    print(paste(" ******** aggregate MU for DC"))
    print(MU)
    
    print(paste(" ******** aggregate MU.EB for DC"))
    print(MU.EB)
    
    print(paste(" ******** aggregate MSPE for DC"))
    print(MSPE)
   
    print(paste(" ******** aggregate MSPE.logit for DC"))
    print(MSPE.logit) 
    
    print(paste(" ******** aggregate mspe.te for DC"))
    print(mspe.te)
    
    print(paste(" ******** aggregate g1 for DC"))
    print(g1)
    
    print(paste(" ******** aggregate g2 for DC"))
    print(g2)
    
    print(paste(" ******** aggregate g11 for DC"))
    print(g11)
    
    print(paste(" ******** aggregate g12 for DC"))
    print(g12)
    
    print(paste(" ******** aggregate Ealpha for DC"))
    print(Ealpha)
    
    print(paste(" ******** aggregate Covalpha for DC"))
    print(Covalpha)
    #-------------------------------------
    save(list = ls(all=TRUE), file =".RData")
    
    date() 
           